#!/bin/bash
KER_VER=`uname -r`
DRIVER_PATH="/lib/modules/$KER_VER/kernel/drivers/usb/misc/"
device="nfrd08c"
major=180

if [ -d $DRIVER_PATH ]; then
	# Do nothing
	echo
else
	echo Driver Path does not exist , will create
	mkdir $DRIVER_PATH
fi

if [ -f $DRIVER_PATH/nfrd08c.ko  ]; then
	echo $DRIVER_PATH"nfrd08c.ko already exists"
	echo run uninstaller  to uninstall drive 
	exit 1
fi

if [ -f nfrd08c.ko  -a  -f nfrd08c.h  ]; then
	drvkernel=`/sbin/modinfo nfrd08c.ko | grep vermagic | cut -f8 -d " "`
	# checking for kernel version with driver compiled version .
	if [ $drvkernel == $KER_VER ]; then
		#echo "copying ----- driver DUMMY  "
		cp -v nfrd08c.ko $DRIVER_PATH
	else
		echo your kernel version $KER_VER does not match with NITGEN USB Driver compiled kernel verion  $drvkernel
		echo you can compile NITGEN USB Fingkey Hamster driver source
		echo and  run this script or Get $KER_VER driver binary from vendor.
		exit 1
	fi
else
	echo "nfrd08c.ko or nfrd08c.h  file not found in current dir ....."
	exit 1;
fi

if [ -f /usr/include/linux/nfrd08c.h ]; then
	echo "nfrd08c.h already exists"
	exit 1
fi

cp -v nfrd08c.h /usr/include/linux/


if [ -f /lib/nfrd08c.so ]; then
	echo "nfrd08c.so already exists"
	exit 1
fi

if [ -f nfrd08c.so ]; then
	cp -v nfrd08c.so /lib/
else
	echo "nfrd08c.so not exist"
	exit 1
fi

if [ -f nfrd08c.conf ]; then
	cp -f nfrd08c.conf /etc/
	chmod 666 /etc/nfrd08c.conf
else
	echo "nfrd08c.conf not exist"
	exit 1
fi

#remove stale node
rm -f /dev/${device}[0-7]
#create 8 nodes for the device
mknod /dev/${device}0 c $major 222
mknod /dev/${device}1 c $major 223
mknod /dev/${device}2 c $major 224
mknod /dev/${device}3 c $major 225
mknod /dev/${device}4 c $major 226
mknod /dev/${device}5 c $major 227
mknod /dev/${device}6 c $major 228
mknod /dev/${device}7 c $major 229

#move  to driver detination directory
cd $DRIVER_PATH
#install the driver module into kernel
/sbin/insmod nfrd08c.ko

echo ""
echo "Please wait for creating a list of module dependencies."
/sbin/depmod -a $KER_VER
echo ""

# start hotplugging
#echo "starting hotplugging ......"
#/bin/sh /etc/init.d/hotplug start
echo "NITGEN USB eNBioScan-C1 Driver sucessfully installed "
echo "Disconnect the Device and Plug it back "

